## Contributing to this project

Please take a moment to review this document in order to make the contribution process easy and effective for everyone involved.  
The issue tracker is the preferred channel for bug reports, features requests and submitting pull requests.

Aslan uses Software Design Description (SDD) documents for new features implementation. The purpose of these documents is to:
- Facilitate the developers working on new features
- Request and provide feedback on the software design
- Manage and maintain the overall architecture of the stack
- Document the software design of new features

There are multiple ways to contribute to this project, as specified below.

#### Bug report
To report a bug on this project, it's recommended to use the [Bug Report template](https://github.com/project-aslan/Aslan/issues/new/choose) on the [Issue Tracker](https://github.com/project-aslan/Aslan/issues).

#### Bug Fix
To submit a new Pull Request with your bug fix, please follow the steps:
1. Open a [new issue](https://github.com/project-aslan/Aslan/issues/new/choose) on github (if you haven't already), specifying the bug you are working on
2. Fork project-aslan/Aslan on your personal GitHub account
3. On your fork, create a new branch called `feature/[IssueNumber]-[Title]` eg. feature/14-FixMelodicDependencies
4. Start working on your branch. Make sure to always keep your fork up-to-date with the latest commits on Aslan
5. Once you have finished working on your feature, create a new Pull Request from your private fork to the *develop* branch of Aslan.
6. Provide a brief description of your feature on your PR and a core developer will review it and provide feedback.
7. When your PR is approved, it will be merged on the develop branch of Aslan.

#### Feature requests
If there is a new feature you would like to suggest for this project, it's recommended to use the [Feature Report template](https://github.com/project-aslan/Aslan/issues/new/choose) on the [Issue Tracker](https://github.com/project-aslan/Aslan/issues).  
After submitting your feature request, please specify if this is a feature you would like to develop (please see more information below) or if it's a general feature suggestion for the other contributors.

#### Develop a new feature
To start developing a new feature, please follow the steps:
1. Create a new Software Design Document (SDD) on the Issue Tracker, using the [template specified](https://github.com/project-aslan/Aslan/issues/new/choose). If you require urgent feedback or further information, assign this to one of the core developers for review. If you would like a core developer to work with you on this project, please feel free to specify on the SDD.
2. Fork project-aslan/Aslan on your personal GitHub account
3. On your fork, create a new branch called `feature/[SDDNumber]-[Title]` eg. feature/14-VehicleInterface
4. Start working on your branch. Make sure to always keep your fork up-to-date with the latest commits on Aslan
5. Once you have finished working on your feature, create a new Pull Request from your branch to the *develop* branch of Aslan.
6. Provide a brief description of your feature on your pull request and a core developer will review it and provide feedback.
7. When your PR is approved, it will be merged on the develop branch of Aslan.



Any contribution that you make to this repository will
be under the Apache 2 License, as dictated by that
[license](http://www.apache.org/licenses/LICENSE-2.0.html):

~~~
5. Submission of Contributions. Unless You explicitly state otherwise,
   any Contribution intentionally submitted for inclusion in the Work
   by You to the Licensor shall be under the terms and conditions of
   this License, without any additional terms or conditions.
   Notwithstanding the above, nothing herein shall supersede or modify
   the terms of any separate license agreement you may have executed
   with Licensor regarding such Contributions.
~~~  

Feel free to contact the Project Aslan team if you need more information at: info@project-aslan.com